/**
 * Copyright (C) 2010 Cloudfarming <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package nl.cloudfarming.client.cropprotection.clm;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.UniformInterfaceException;
import com.sun.jersey.api.client.WebResource;

/** Jersey REST client generated for REST resource:ClmWadl-xml [clm/crop_protection.php]<br>
 *  USAGE:<pre>
 *        AuthorizationServiceLayer client = new AuthorizationServiceLayer();
 *        Object response = client.XXX(...);
 *        // do whatever with response
 *        client.close();
 *  </pre>
 * @author merijn
 */
public class AuthorizationServiceLayer {
    private WebResource webResource;
    private Client client;
    private static final String BASE_URI = "http://www.agrosense.nl";

    AuthorizationServiceLayer() {
        com.sun.jersey.api.client.config.ClientConfig config = new com.sun.jersey.api.client.config.DefaultClientConfig();
        client = Client.create(config);
        webResource = client.resource(BASE_URI).path("clm/crop_protection.php");
    }

    /**
     * @param responseType Class representing the response
     * @param getAgent query parameter[REQUIRED]
     * @return response object (instance of responseType class)
     */
    <T> T getAgent(Class<T> responseType, String getAgent) throws UniformInterfaceException {
        return webResource.queryParam("getAgent", getAgent).accept(javax.ws.rs.core.MediaType.TEXT_XML).get(responseType);
    }

    /**
     * @param responseType Class representing the response
     * @param getCrop query parameter[REQUIRED]
     * @return response object (instance of responseType class)
     */
    <T> T getCrop(Class<T> responseType, String getCrop) throws UniformInterfaceException {
        return webResource.queryParam("getCrop", getCrop).accept(javax.ws.rs.core.MediaType.TEXT_XML).get(responseType);
    }

    /**
     * @param responseType Class representing the response
     * @param getDeterioraration query parameter[REQUIRED]
     * @return response object (instance of responseType class)
     */
    <T> T getDeterioration(Class<T> responseType, String getDeterioraration) throws UniformInterfaceException {
        return webResource.queryParam("getDeterioraration", getDeterioraration).accept(javax.ws.rs.core.MediaType.TEXT_XML).get(responseType);
    }

    public void close() {
        client.destroy();
    }
    
}
